
#include <qcstring.h>
#include <qsocket.h>
#include <qdatetime.h>
#include <qbitarray.h>

#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include <qdir.h>
#include <qfile.h>


#include <kapplication.h>
#include <kdebug.h>
#include <kmessagebox.h>
#include <kinstance.h>
#include <kglobal.h>
#include <kstandarddirs.h>
#include <klocale.h>
#include <kurl.h>
#include <ksock.h>

#include "tvkio.h"

using namespace KIO;

//this KIO slave lists a directory and displays it prettily
//to create icons you must put an image in FOLDER/folder.jpg
//this is designed for wide icon used by XBMC
//The plan is to allow it to list mulitple directories and combine them



//construct
kio_tvkioProtocol::kio_tvkioProtocol(const QCString &pool_socket, const QCString &app_socket)
    : SlaveBase("kio_tvkio", pool_socket, app_socket)
{
    kdDebug() << "kio_tvkioProtocol::kio_tvkioProtocol()" << endl;
}

//destruct
kio_tvkioProtocol::~kio_tvkioProtocol()
{
    kdDebug() << "kio_tvkioProtocol::~kio_tvkioProtocol()" << endl;
}

//show = TV show name, Base = source of that folder
QString kio_tvkioProtocol::item(QString show, QString base)
{
	QString html = "<div class=\"show\"><a href=\"file:"+base+show+"/\">";
	if(QFile::exists(base+show+"/folder.jpg"))
	{
		html+="<img src=\"file:"+base+show+"/folder.jpg\" alt=\""+show+"\"/>";
		html += "</a>";
	}
	else
	{
		//use all of the KDE dir variables
		html+="<img src=\"file:/usr/share/apps/kio_tv/empty.png\">";
		html+="<h3>"+show+"</h3>";
		html+="</a>";
		html+="<a class=\"fetch_link\" href=\"http://mediaicons.org\">GetIcon</a>";
	}
	html+="</div>";
	return html;
}

QString kio_tvkioProtocol::list_all(QString base)
{
	QString html="";	
	//connect to the directory

	QDir dir = QDir(base);
	QStringList items = dir.entryList(QDir::Dirs );
    	//foreach (in effect), note item is a pointer
	for ( QStringList::Iterator item = items.begin(); item != items.end(); ++item )
	{
		QString folder= QString(*item);
		//don't show "." or ".."
		if(folder.left(1)!=".")
			html+=kio_tvkioProtocol::item(folder,base);
	}
	return html;
}



void kio_tvkioProtocol::get(const KURL& url )
{
	QString base=url.path(+1);
	mimeType("text/html");

	QFile header("/usr/share/apps/kio_tv/header.html");
	header.open(IO_ReadOnly);
	QString theData=header.readAll();

	header.close();

	theData+=kio_tvkioProtocol::list_all(base);
	theData+="</html>";

    //send theData to the screen
    data(QCString(theData));
    data(QByteArray()); // empty array means we're done sending the data
    finished();
}


void kio_tvkioProtocol::mimetype(const KURL & /*url*/)
{
    mimeType("text/html");
    finished();
}

//not sure what this does - it looks complicated though
extern "C"
{
    int kdemain(int argc, char **argv)
    {
        KInstance instance( "kio_tvkio" );
        
        kdDebug(7101) << "*** Starting kio_tvkio " << endl;
        
        if (argc != 4) {
            kdDebug(7101) << "Usage: kio_tvkio  protocol domain-socket1 domain-socket2" << endl;
            exit(-1);
        }
        
        kio_tvkioProtocol slave(argv[2], argv[3]);
        slave.dispatchLoop();
        
        kdDebug(7101) << "*** kio_tvkio Done" << endl;
        return 0;
    }
} 
